//
//  ShareRecordModel.h
//  双子星云手机
//
//  Created by xd h on 2024/5/18.
//

#import "SuperModel.h"
#import "BGFMDB.h" //添加该头文件,本类就具有了存储功能.

NS_ASSUME_NONNULL_BEGIN

typedef enum{
    saveBoxStateBegin = 0,
    saveBoxStateUploading,//占位 未用到
    saveBoxStateSuspend,//占位 未用到
    saveBoxStateDone,
    saveBoxStateFail,
}shareSaveBoxStateType;

typedef enum{
    //downloadBoxStateBegin = 0,
    downloadBoxStateDownloadloading = 0,//占位 未用到
    downloadBoxStateSuspend,//
    downloadBoxStateDone,
    downloadBoxStateFail,
}shareDownloadBoxStateType;

@interface ShareFileDataModel : SuperModel
@property (nonatomic, copy) NSString*fileName;
@property (nonatomic, copy) NSString*fileSize;
@property (nonatomic, copy) NSString*fileTime;
@property (nonatomic, copy) NSString*fileUrl;
@property (nonatomic, copy) NSString*headUrl;
//@property (nonatomic, assign) long  size;
//id

//自定义 保存
@property (nonatomic, assign) shareSaveBoxStateType saveboxStateType;
@property (nonatomic, copy) NSString*boxSavePath;//保存目录

//1.4.1 增加
@property (nonatomic, assign) CGFloat saveProgress;//0---1
@property (nonatomic, assign) NSInteger downloadStatus;////0 等待   1 成功  2 失败  3开始  4文件不存在  5失败  -1失败

//下载
@property (nonatomic, assign) shareDownloadBoxStateType downloadBoxStateType;
@property (nonatomic, copy) NSString*failMsg;//错误信息
/** 下载的文件总大小 */
@property (nonatomic,assign) int64_t totalSize;

/** 当前下载了多少 */
@property (nonatomic,assign) int64_t currentSize;
@property (nonatomic, assign)  int64_t preDownloadBytes;//已经上传的字节数

@property (nonatomic, assign) NSTimeInterval  preTimeInterval;//计算速度用
@property (nonatomic, assign) NSTimeInterval  curTimeInterval;//计算速度用

@end

@protocol ShareFileDataModel;
@interface ShareRecordListModel : SuperModel
@property (nonatomic, assign) NSInteger expirationDay;//有效期
@property (nonatomic, copy) NSString* extractionCode;//提取码
@property (nonatomic, copy) NSString* token;//
@property (nonatomic, copy) NSString* sn;//
@property (nonatomic, copy) NSString* addShareId;//
@property (nonatomic, assign) NSInteger fileType;
@property (nonatomic, assign) NSInteger platformType;//平台类型 1=微信 2=QQ 3=朋友圈 4=私密
@property (nonatomic, assign) NSInteger expirationStatus;//过期状态 0=有效 1=失效
@property (nonatomic, copy) NSString* expirationTime;//
@property (nonatomic, copy) NSString* createTime;
          
//1.4.1 新增字段
@property (nonatomic, assign) NSInteger remainingNumber;//剩余次数
@property (nonatomic, assign) NSInteger shareNumber;//分享次数
@property (nonatomic, assign) BOOL reportStatus;//举报状态 0=未举报 1=已举报
@property (nonatomic, copy) NSString* reportTime;//举报时间

@property (nonatomic, strong) NSArray<ShareFileDataModel>* fileListVOS;

//自定义
@property (nonatomic, assign) BOOL isSelectType;
@end

@protocol ShareRecordListModel;
@interface ShareRecordModel : SuperModel
@property (nonatomic, strong) NSArray<ShareRecordListModel>* data;
@end

NS_ASSUME_NONNULL_END
