//
//  editTypeBottomView.m
//  双子星云手机
//
//  Created by xd h on 2024/5/14.
//

#import "editTypeBottomView.h"

@interface editTypeBottomView ()
@property(nonatomic,strong) UIButton*leftButton;
@property(nonatomic,strong) UIImageView*leftImageV;
@property(nonatomic,strong) UILabel *leftLabel;

@property(nonatomic,strong) UIButton*rightButton;
@property(nonatomic,strong) UIImageView*rightImageV;
@property(nonatomic,strong) UILabel *rightLabel;

@property(nonatomic,strong) UIButton*midButton;
@property(nonatomic,strong) UIImageView*midImageV;
@property(nonatomic,strong) UILabel *midLabel;
@end

@implementation editTypeBottomView

- (id)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    self.backgroundColor = [UIColor whiteColor];
    [self drawAnyView];
    return self;
}

- (void)drawAnyView{
    
    CGFloat curButFullWidth = SCREEN_W/3.0;
    
    _leftButton = [[UIButton alloc] init];
    [_leftButton addTarget:self action:@selector(didClickButFun:) forControlEvents:UIControlEventTouchUpInside];
    _leftButton.tag = 1;
    [self addSubview:_leftButton];
    
    [_leftButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(curButFullWidth);
        make.left.mas_equalTo(0);
        make.height.mas_equalTo(60);
        make.top.mas_equalTo(0);
    }];
    
    _leftImageV = [[UIImageView alloc] init];
    _leftImageV.image = [UIImage imageNamed:@"edit_download_icon"];
    [_leftButton addSubview:_leftImageV];
    
    [_leftImageV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(25);
        make.height.mas_equalTo(25);
        make.centerX.equalTo(_leftButton.mas_centerX);
        make.centerY.equalTo(_leftButton.mas_centerY).offset(-10);
    }];
    
    _leftLabel = [[UILabel alloc] init];
    _leftLabel.textColor = [UIColor hwColor:@"#0A132B"];
    _leftLabel.textAlignment = NSTextAlignmentCenter;
    _leftLabel.font = [UIFont systemFontOfSize:12.0];
    _leftLabel.text = NSLocalizedString(@"my_set_no_File_download",nil);
    [_leftButton addSubview:_leftLabel];
    
    [_leftLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(curButFullWidth);
        make.height.mas_equalTo(25);
        make.centerX.equalTo(_leftButton.mas_centerX);
        make.centerY.equalTo(_leftButton.mas_centerY).offset(10);
    }];
    
    _midButton = [[UIButton alloc] init];
    [_midButton addTarget:self action:@selector(didClickButFun:) forControlEvents:UIControlEventTouchUpInside];
    _midButton.tag = 2;
    [self addSubview:_midButton];
    
    [_midButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(curButFullWidth);
        make.left.mas_equalTo(curButFullWidth);
        make.height.mas_equalTo(60);
        make.top.mas_equalTo(0);
    }];
    
    _midImageV = [[UIImageView alloc] init];
    _midImageV.image = [UIImage imageNamed:@"edit_share_icon"];
    [_midButton addSubview:_midImageV];
    
    [_midImageV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(25);
        make.height.mas_equalTo(25);
        make.centerX.equalTo(_midButton.mas_centerX);
        make.centerY.equalTo(_midButton.mas_centerY).offset(-10);
    }];
    
    _midLabel = [[UILabel alloc] init];
    _midLabel.textColor = [UIColor hwColor:@"#0A132B"];
    _midLabel.textAlignment = NSTextAlignmentCenter;
    _midLabel.font = [UIFont systemFontOfSize:12.0];
    _midLabel.text = NSLocalizedString(@"common_edit_share",nil);
    [_midButton addSubview:_midLabel];
    
    [_midLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(curButFullWidth);
        make.height.mas_equalTo(25);
        make.centerX.equalTo(_midButton.mas_centerX);
        make.centerY.equalTo(_midButton.mas_centerY).offset(10);
    }];
    
    
    _rightButton = [[UIButton alloc] init];
    [_rightButton addTarget:self action:@selector(didClickButFun:) forControlEvents:UIControlEventTouchUpInside];
    _rightButton.tag = 3;
    [self addSubview:_rightButton];
    
    [_rightButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(curButFullWidth);
        make.right.mas_equalTo(0);
        make.height.mas_equalTo(60);
        make.top.mas_equalTo(0);
    }];
    
    _rightImageV = [[UIImageView alloc] init];
    _rightImageV.image = [UIImage imageNamed:@"edit_del_icon"];
    [_rightButton addSubview:_rightImageV];
    
    [_rightImageV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(25);
        make.height.mas_equalTo(25);
        make.centerX.equalTo(_rightButton.mas_centerX);
        make.centerY.equalTo(_rightButton.mas_centerY).offset(-10);
    }];
    
    _rightLabel = [[UILabel alloc] init];
    _rightLabel.textColor = [UIColor hwColor:@"#0A132B"];
    _rightLabel.textAlignment = NSTextAlignmentCenter;
    _rightLabel.font = [UIFont systemFontOfSize:12.0];
    _rightLabel.text = NSLocalizedString(@"File_upload_Record_delete",nil);
    [_rightButton addSubview:_rightLabel];
    
    [_rightLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(curButFullWidth);
        make.height.mas_equalTo(25);
        make.centerX.equalTo(_rightButton.mas_centerX);
        make.centerY.equalTo(_rightButton.mas_centerY).offset(10);
    }];
//    
}

- (void)didClickButFun:(UIButton*)but
{
    NSInteger tag = but.tag;
    
    if(_didClickButtonFun){
        _didClickButtonFun(tag);
    }
}


- (void)setButtonStateFunBy:(BOOL)canClick
{
    CGFloat alpha = canClick ? 1.0 : 0.5;
    _leftButton.enabled = canClick;
    _rightButton.enabled = canClick;
    _midButton.enabled = canClick;
    
    _leftButton.alpha = alpha;
    _rightButton.alpha = alpha;
    _midButton.alpha = alpha;
}

- (void)setCanShaewFunBy:(BOOL)canShare
{
    //test code
    //canShare = NO;
   
    _midButton.hidden = !canShare;
    
    if(canShare){
        CGFloat curButFullWidth = SCREEN_W/3.0;
        [_leftButton mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.width.mas_equalTo(curButFullWidth);
            make.left.mas_equalTo(0);
            make.height.mas_equalTo(60);
            make.top.mas_equalTo(0);
        }];
        
        [_midButton mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.width.mas_equalTo(curButFullWidth);
            make.left.mas_equalTo(curButFullWidth);
            make.height.mas_equalTo(60);
            make.top.mas_equalTo(0);
        }];
        
        [_rightButton mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.width.mas_equalTo(curButFullWidth);
            make.right.mas_equalTo(0);
            make.height.mas_equalTo(60);
            make.top.mas_equalTo(0);
        }];
    }
    else{
        CGFloat curButFullWidth = SCREEN_W/2.0;
        [_leftButton mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.width.mas_equalTo(curButFullWidth);
            make.left.mas_equalTo(0);
            make.height.mas_equalTo(60);
            make.top.mas_equalTo(0);
        }];
        
//        [_midButton mas_remakeConstraints:^(MASConstraintMaker *make) {
//            make.width.mas_equalTo(curButFullWidth);
//            make.left.mas_equalTo(curButFullWidth);
//            make.height.mas_equalTo(60);
//            make.top.mas_equalTo(0);
//        }];
        
        [_rightButton mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.width.mas_equalTo(curButFullWidth);
            make.right.mas_equalTo(0);
            make.height.mas_equalTo(60);
            make.top.mas_equalTo(0);
        }];
    }
}

- (void)setIsBlackType:(BOOL)isBlackType
{
    _isBlackType = isBlackType;
    if(isBlackType){
        self.backgroundColor = [UIColor clearColor];
        
        // gradient
        CAGradientLayer *gl = [CAGradientLayer layer];
        gl.frame = CGRectMake(0,0,SCREEN_W,60 + AdaptTabHeight);
        gl.startPoint = CGPointMake(0.5, 0);
        gl.endPoint = CGPointMake(0.5, 1);
        gl.colors = @[(__bridge id)[UIColor colorWithRed:0/255.0 green:0/255.0 blue:0/255.0 alpha:0.0].CGColor, (__bridge id)[UIColor colorWithRed:0/255.0 green:0/255.0 blue:0/255.0 alpha:1.0].CGColor];
        gl.locations = @[@(0), @(1.0f)];
        //[self.layer addSublayer:gl];
        [self.layer insertSublayer:gl atIndex:0];
        
        self.layer.shadowColor = [UIColor colorWithRed:0/255.0 green:0/255.0 blue:0/255.0 alpha:0.0200].CGColor;
        self.layer.shadowOffset = CGSizeMake(0,-1);
        self.layer.shadowOpacity = 1;
        self.layer.shadowRadius = 1;
        
        //
        _leftImageV.image = [UIImage imageNamed:@"edit_download_white_icon"];
        _leftLabel.textColor = [UIColor whiteColor];
        
        _midImageV.image = [UIImage imageNamed:@"edit_share_white_icon"];
        _midLabel.textColor = [UIColor whiteColor];
        
        _rightImageV.image = [UIImage imageNamed:@"edit_del_white_icon"];
        _rightLabel.textColor = [UIColor whiteColor];
    }
}
@end
