//
//  shareRecordTableViewCell.m
//  双子星云手机
//
//  Created by xd h on 2024/5/14.
//

#import "shareRecordTableViewCell.h"

@interface shareRecordTableViewCell ()

@property(nonatomic,strong)UIImageView *mImageView;
@property(nonatomic,strong)UILabel *titleLabel;
@property(nonatomic,strong)UILabel *titleLabel2;
@property(nonatomic,strong)UIImageView *rightImage;
@property (nonatomic, strong) UIButton *selectButton;
@property(nonatomic,strong)UIImageView *lockImageView;
@property(nonatomic,strong)UILabel *stateLabel;
@property(nonatomic,strong)UILabel *remainingNumberLabel;//剩余分享次数
@end

@implementation shareRecordTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    
    if (self)
    {
        [self drawView];
    }
    
    return self;
}

- (void)drawView
{
    
    /*图片*/
    _mImageView = [[UIImageView alloc] init];
    [_mImageView setBackgroundColor:[UIColor clearColor]];
    _mImageView.image = [UIImage imageNamed:@"uploadFile_file_icon"];
    [self.contentView addSubview:_mImageView];
    [_mImageView setContentMode:(UIViewContentModeScaleAspectFit)];
    [_mImageView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(15);
        make.width.mas_equalTo(36);
        make.height.mas_equalTo(36);
        make.centerY.equalTo(self.mas_centerY);
    }];
    
    /*右侧箭头*/
    _rightImage = [[UIImageView alloc] init];
    [_rightImage setBackgroundColor:[UIColor clearColor]];
    [_rightImage setImage:[UIImage imageNamed:@"cell_right_access"]];
    [self.contentView addSubview:_rightImage];
    [_rightImage mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(28);
        make.right.mas_equalTo(-15.f);
        make.height.mas_equalTo(28);
        make.centerY.equalTo(self.mas_centerY);
    }];
    
    UIButton *but = [[UIButton alloc] init];
    [but setImage:[UIImage imageNamed:@"common_un_check_24"] forState:UIControlStateNormal];
    [but setImage:[UIImage imageNamed:@"common_did_check_24"] forState:UIControlStateSelected];
    [self.contentView addSubview:but];
    [but addTarget:self action:@selector(didClickButFun:) forControlEvents:UIControlEventTouchUpInside];
    but.hidden = YES;

    [but mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(28);
        make.right.mas_equalTo(-15.f);
        make.height.mas_equalTo(28);
        make.centerY.equalTo(self.mas_centerY);
    }];
    
    self.selectButton = but;
    
    _remainingNumberLabel = [[UILabel alloc] init];
    [self.contentView addSubview:_remainingNumberLabel];
    _remainingNumberLabel.textAlignment = NSTextAlignmentRight;
    _remainingNumberLabel.font = [UIFont systemFontOfSize:12.f];
    [_remainingNumberLabel setTextColor:HW666666Color]; //#01B7EA
    [_remainingNumberLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(80);
        make.right.equalTo(_rightImage.mas_left).offset(-5.f);
        //make.centerY.equalTo(self.mas_centerY);
        make.top.mas_equalTo(15.f);
    }];
    
    _stateLabel = [[UILabel alloc] init];
    [self.contentView addSubview:_stateLabel];
    _stateLabel.textAlignment = NSTextAlignmentRight;
    _stateLabel.font = [UIFont systemFontOfSize:12.f];
    [_stateLabel setTextColor:HW666666Color]; //#01B7EA
    [_stateLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(80);
        make.right.equalTo(_rightImage.mas_left).offset(-5.f);
        //make.centerY.equalTo(self.mas_centerY);
        //make.top.mas_equalTo(15.f);
        make.top.equalTo(_remainingNumberLabel.mas_bottom).offset(7);
    }];
    
    
    
    /**标题*/
    _titleLabel = [[UILabel alloc] init];
    [self.contentView addSubview:_titleLabel];
    _titleLabel.font = [UIFont boldSystemFontOfSize:14.f];
    _titleLabel.numberOfLines = 1;
    _titleLabel.lineBreakMode = NSLineBreakByTruncatingMiddle;
    [_titleLabel setTextColor:HW0A132BColor];
    [_titleLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(_mImageView.mas_right).offset(5.f);
        make.right.equalTo(_stateLabel.mas_left).offset(-5.f);
        //make.centerY.equalTo(self.mas_centerY);
        make.top.mas_equalTo(15.f);
    }];
    
    
    
    _lockImageView = [[UIImageView alloc] init];
    [_lockImageView setImage:[UIImage imageNamed:@"share_lock_icon"]];
    [self.contentView addSubview:_lockImageView];
    [_lockImageView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(16);
        make.height.mas_equalTo(16);
        make.left.equalTo(_titleLabel.mas_left);
        make.top.equalTo(_titleLabel.mas_bottom).offset(5);
    }];
    
    /**副标题*/
    _titleLabel2 = [[UILabel alloc] init];
    [self.contentView  addSubview:_titleLabel2];
    _titleLabel2.font = [UIFont systemFontOfSize:12.f];
    //[titleLabel2 setTextAlignment:(NSTextAlignmentRight)];
    [_titleLabel2 setTextColor:HW666666Color];
    [_titleLabel2 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(_titleLabel.mas_right);
        make.left.equalTo(_lockImageView.mas_right);
        make.centerY.equalTo(_lockImageView.mas_centerY);
        make.height.mas_equalTo(16);
    }];
    
    
    
}

- (void)setIsEditType:(BOOL)isEditType
{
    if(isEditType){
        _rightImage.hidden = YES;
        _selectButton.hidden = NO;
    }
    else{
        _rightImage.hidden = NO;
        _selectButton.hidden = YES;
    }
}

- (void)setDataModel:(ShareRecordListModel *)dataModel
{
    _dataModel = dataModel;
    
    _selectButton.selected = _dataModel.isSelectType;
    
    //剩余次数
    _remainingNumberLabel.text = [[NSString alloc] initWithFormat:@"%@ %ld",NSLocalizedString(@"share_number_remainingNumber_tip",nil),_dataModel.remainingNumber];
    
    if(_dataModel.expirationStatus || _dataModel.reportStatus){
        _stateLabel.text = NSLocalizedString(@"copy_share_link_Invalid_tip",nil);
        
        if(_dataModel.reportStatus){
            _stateLabel.text = NSLocalizedString(@"share_report_tip2",nil);
        }
        
        [_stateLabel setTextColor:HW666666Color]; //#01B7EA
    }
    else{
        if(_dataModel.expirationDay== 0)
        {
            NSString *expDateStr = NSLocalizedString(@"share_expiration_date_forever",nil);
            _stateLabel.text = expDateStr;
        }
        else{
            //计算失效时间
            NSString *expDateStr = [iTools getTimeStringToExpirationDate:_dataModel.expirationTime];
            //NSString *tipStr = NSLocalizedString(@"copy_share_link_Invalid_tip2",nil);
            //_stateLabel.text = [[NSString alloc] initWithFormat:@"%@%@",expDateStr,tipStr];
            _stateLabel.text = [[NSString alloc] initWithFormat:@"%@",expDateStr];
        }
        NSString *tipStr =  NSLocalizedString(@"copy_share_link_Invalid_tip",nil);
        if([_stateLabel.text isEqualToString:tipStr]){
            [_stateLabel setTextColor:[UIColor hwColor:@"#666666"]];
        }
        else{
            [_stateLabel setTextColor:[UIColor hwColor:@"#01B7EA"]];
        }
        
    }
    
    ShareFileDataModel *fileModel = _dataModel.fileListVOS.firstObject;
    NSString *titleStr = [[NSString alloc] initWithFormat:@"%@%@%ld%@",fileModel.fileName,NSLocalizedString(@"share_file_more_tip",nil), _dataModel.fileListVOS.count,NSLocalizedString(@"share_file_Numbers_tip",nil)];
    
    if(_dataModel.fileListVOS.count == 1){
        titleStr = fileModel.fileName;
    }
    
    _titleLabel.text = titleStr;
    _titleLabel2.text = _dataModel.createTime;
    
    if(_dataModel.platformType == 4){
        _lockImageView.hidden = NO;
        /**副标题*/
        [_titleLabel2 mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.right.equalTo(_titleLabel.mas_right);
            make.left.equalTo(_lockImageView.mas_right);
            make.centerY.equalTo(_lockImageView.mas_centerY);
            make.height.mas_equalTo(16);
        }];
    }
    else{
        _lockImageView.hidden = YES;
        [_titleLabel2 mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.right.equalTo(_titleLabel.mas_right);
            make.left.equalTo(_lockImageView.mas_left);
            make.centerY.equalTo(_lockImageView.mas_centerY);
            make.height.mas_equalTo(16);
        }];
    }
}

- (void)didClickButFun:(UIButton*)but
{
    but.selected = !but.selected;
    
    if(_didClickSwitch){
        _didClickSwitch(but.selected);
    }
}

@end
